/*

    Ophcrack is a Lanmanager/NTLM hash cracker based on the faster time-memory
    trade-off using rainbow tables. 
    
    Created with the help of: Maxime Mueller, Luca Wullschleger, Claude
    Hochreutiner and Andreas Huber.

    Copyright 2005 Philippe Oechslin, Cedric Tissieres

    Ophcrack is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Ophcrack is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Ophcrack; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

static char rcsid[] = "$Id: interface.c,v 2.0 2005/03/24 tissieres Exp $";

/* 
 * $Log: interface.c,v $
 * Revision 2.0  2005/03/24 tissieres
 * Initial revision
 *
 */


/*
 * DO NOT EDIT THIS FILE - it is generated by Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

GtkWidget*
create_main_window (void)
{
  GtkWidget *main_window;
  GdkPixbuf *main_window_icon_pixbuf;
  GtkWidget *vbox1;
  GtkWidget *toolbar1;
  GtkIconSize tmp_toolbar_icon_size;
  GtkWidget *tmp_image;
  GtkWidget *dump1;
  GtkWidget *load_file1;
  GtkWidget *launch1;
  GtkWidget *save_button;
  GtkWidget *exit1;
  GtkWidget *about_button;
  GtkWidget *scrolledwindow1;
  GtkWidget *hash_list;
  GtkWidget *scrolledwindow2;
  GtkWidget *textview1;
  GtkWidget *statusbar1;

  main_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (main_window), "ophcrack");
  gtk_window_set_default_size (GTK_WINDOW (main_window), 700, 560);
  main_window_icon_pixbuf = create_pixbuf ("os.xpm");
  if (main_window_icon_pixbuf)
    {
      gtk_window_set_icon (GTK_WINDOW (main_window), main_window_icon_pixbuf);
      gdk_pixbuf_unref (main_window_icon_pixbuf);
    }

  vbox1 = gtk_vbox_new (FALSE, 10);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (main_window), vbox1);

  toolbar1 = gtk_toolbar_new ();
  gtk_widget_show (toolbar1);
  gtk_box_pack_start (GTK_BOX (vbox1), toolbar1, FALSE, FALSE, 0);
  gtk_toolbar_set_style (GTK_TOOLBAR (toolbar1), GTK_TOOLBAR_BOTH);
  tmp_toolbar_icon_size = gtk_toolbar_get_icon_size (GTK_TOOLBAR (toolbar1));

  tmp_image = gtk_image_new_from_stock ("gtk-harddisk", tmp_toolbar_icon_size);
  gtk_widget_show (tmp_image);
  dump1 = (GtkWidget*) gtk_tool_button_new (tmp_image, "Dump...");
  gtk_widget_show (dump1);
  gtk_container_add (GTK_CONTAINER (toolbar1), dump1);

  tmp_image = gtk_image_new_from_stock ("gtk-open", tmp_toolbar_icon_size);
  gtk_widget_show (tmp_image);
  load_file1 = (GtkWidget*) gtk_tool_button_new (tmp_image, "Load File...");
  gtk_widget_show (load_file1);
  gtk_container_add (GTK_CONTAINER (toolbar1), load_file1);

  launch1 = (GtkWidget*) gtk_toggle_tool_button_new ();
  gtk_tool_button_set_label (GTK_TOOL_BUTTON (launch1), "Launch");
  tmp_image = gtk_image_new_from_stock ("gtk-execute", tmp_toolbar_icon_size);
  gtk_widget_show (tmp_image);
  gtk_tool_button_set_icon_widget (GTK_TOOL_BUTTON (launch1), tmp_image);
  gtk_widget_show (launch1);
  gtk_container_add (GTK_CONTAINER (toolbar1), launch1);
  gtk_widget_set_sensitive (launch1, FALSE);

  save_button = (GtkWidget*) gtk_tool_button_new_from_stock ("gtk-save-as");
  gtk_widget_show (save_button);
  gtk_container_add (GTK_CONTAINER (toolbar1), save_button);
  gtk_widget_set_sensitive (save_button, FALSE);

  tmp_image = gtk_image_new_from_stock ("gtk-quit", tmp_toolbar_icon_size);
  gtk_widget_show (tmp_image);
  exit1 = (GtkWidget*) gtk_tool_button_new (tmp_image, "Exit");
  gtk_widget_show (exit1);
  gtk_container_add (GTK_CONTAINER (toolbar1), exit1);

  tmp_image = create_pixmap (main_window, "os.xpm");
  gtk_widget_show (tmp_image);
  about_button = (GtkWidget*) gtk_tool_button_new (tmp_image, "About");
  gtk_widget_show (about_button);
  gtk_container_add (GTK_CONTAINER (toolbar1), about_button);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_SHADOW_IN);

  hash_list = gtk_tree_view_new ();
  gtk_widget_show (hash_list);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), hash_list);
  gtk_tree_view_set_enable_search (GTK_TREE_VIEW (hash_list), FALSE);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow2, FALSE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  textview1 = gtk_text_view_new ();
  gtk_widget_show (textview1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), textview1);
  gtk_widget_set_size_request (textview1, -1, 100);
  gtk_text_view_set_editable (GTK_TEXT_VIEW (textview1), FALSE);
  gtk_text_view_set_accepts_tab (GTK_TEXT_VIEW (textview1), FALSE);
  gtk_text_view_set_cursor_visible (GTK_TEXT_VIEW (textview1), FALSE);
  gtk_text_view_set_pixels_above_lines (GTK_TEXT_VIEW (textview1), 5);
  gtk_text_view_set_pixels_below_lines (GTK_TEXT_VIEW (textview1), 5);
  gtk_text_view_set_left_margin (GTK_TEXT_VIEW (textview1), 10);
  gtk_text_view_set_right_margin (GTK_TEXT_VIEW (textview1), 10);

  statusbar1 = gtk_statusbar_new ();
  gtk_widget_show (statusbar1);
  gtk_box_pack_start (GTK_BOX (vbox1), statusbar1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (statusbar1), 1);

  g_signal_connect ((gpointer) main_window, "destroy",
                    G_CALLBACK (gtk_main_quit),
                    NULL);
  g_signal_connect ((gpointer) dump1, "clicked",
                    G_CALLBACK (on_dump1_clicked),
                    NULL);
  g_signal_connect ((gpointer) load_file1, "clicked",
                    G_CALLBACK (on_load_file1_activate),
                    NULL);
  g_signal_connect_swapped ((gpointer) launch1, "toggled",
                            G_CALLBACK (on_launch1_toggled),
                            GTK_OBJECT (launch1));
  g_signal_connect ((gpointer) save_button, "clicked",
                    G_CALLBACK (on_save_button_clicked),
                    NULL);
  g_signal_connect ((gpointer) exit1, "clicked",
                    G_CALLBACK (on_exit1_activate),
                    NULL);
  g_signal_connect ((gpointer) about_button, "clicked",
                    G_CALLBACK (on_about_button_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (main_window, main_window, "main_window");
  GLADE_HOOKUP_OBJECT (main_window, vbox1, "vbox1");
  GLADE_HOOKUP_OBJECT (main_window, toolbar1, "toolbar1");
  GLADE_HOOKUP_OBJECT (main_window, dump1, "dump1");
  GLADE_HOOKUP_OBJECT (main_window, load_file1, "load_file1");
  GLADE_HOOKUP_OBJECT (main_window, launch1, "launch1");
  GLADE_HOOKUP_OBJECT (main_window, save_button, "save_button");
  GLADE_HOOKUP_OBJECT (main_window, exit1, "exit1");
  GLADE_HOOKUP_OBJECT (main_window, about_button, "about_button");
  GLADE_HOOKUP_OBJECT (main_window, scrolledwindow1, "scrolledwindow1");
  GLADE_HOOKUP_OBJECT (main_window, hash_list, "hash_list");
  GLADE_HOOKUP_OBJECT (main_window, scrolledwindow2, "scrolledwindow2");
  GLADE_HOOKUP_OBJECT (main_window, textview1, "textview1");
  GLADE_HOOKUP_OBJECT (main_window, statusbar1, "statusbar1");

  return main_window;
}

GtkWidget*
create_dialog1 (void)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *label3;
  GtkWidget *dialog_action_area1;
  GtkWidget *button3;

  dialog1 = gtk_dialog_new ();
  gtk_container_set_border_width (GTK_CONTAINER (dialog1), 15);
  gtk_window_set_title (GTK_WINDOW (dialog1), "File Error");
  gtk_window_set_type_hint (GTK_WINDOW (dialog1), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_widget_show (dialog_vbox1);

  label3 = gtk_label_new ("Error: no valid hash was found in this file.");
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), label3, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_CENTER);
  gtk_label_set_line_wrap (GTK_LABEL (label3), TRUE);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

  button3 = gtk_button_new_with_mnemonic ("OK");
  gtk_widget_show (button3);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button3, 0);

  g_signal_connect_swapped ((gpointer) button3, "clicked",
                            G_CALLBACK (gtk_widget_destroy),
                            GTK_OBJECT (dialog1));

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (dialog1, dialog1, "dialog1");
  GLADE_HOOKUP_OBJECT_NO_REF (dialog1, dialog_vbox1, "dialog_vbox1");
  GLADE_HOOKUP_OBJECT (dialog1, label3, "label3");
  GLADE_HOOKUP_OBJECT_NO_REF (dialog1, dialog_action_area1, "dialog_action_area1");
  GLADE_HOOKUP_OBJECT (dialog1, button3, "button3");

  return dialog1;
}

GtkWidget*
create_filechooserdialog1 (void)
{
  GtkWidget *filechooserdialog1;
  GtkWidget *dialog_vbox2;
  GtkWidget *textview2;
  GtkWidget *dialog_action_area2;
  GtkWidget *cancel_button2;
  GtkWidget *ok_button2;

  filechooserdialog1 = gtk_file_chooser_dialog_new ("Choose", NULL, GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, NULL);
  gtk_window_set_type_hint (GTK_WINDOW (filechooserdialog1), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox2 = GTK_DIALOG (filechooserdialog1)->vbox;
  gtk_widget_show (dialog_vbox2);

  textview2 = gtk_text_view_new ();
  gtk_widget_show (textview2);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), textview2, FALSE, FALSE, 0);
  gtk_text_view_set_editable (GTK_TEXT_VIEW (textview2), FALSE);
  gtk_text_view_set_accepts_tab (GTK_TEXT_VIEW (textview2), FALSE);
  gtk_text_view_set_justification (GTK_TEXT_VIEW (textview2), GTK_JUSTIFY_CENTER);
  gtk_text_view_set_cursor_visible (GTK_TEXT_VIEW (textview2), FALSE);
  gtk_text_buffer_set_text (gtk_text_view_get_buffer (GTK_TEXT_VIEW (textview2)), "Select the directory containing the encrypted SAM and the SYSTEM file.\n(Usually under C:\\WINDOWS\\system32\\config\\)", -1);

  dialog_action_area2 = GTK_DIALOG (filechooserdialog1)->action_area;
  gtk_widget_show (dialog_action_area2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area2), GTK_BUTTONBOX_END);

  cancel_button2 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancel_button2);
  gtk_dialog_add_action_widget (GTK_DIALOG (filechooserdialog1), cancel_button2, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancel_button2, GTK_CAN_DEFAULT);

  ok_button2 = gtk_button_new_from_stock ("gtk-open");
  gtk_widget_show (ok_button2);
  gtk_dialog_add_action_widget (GTK_DIALOG (filechooserdialog1), ok_button2, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (ok_button2, GTK_CAN_DEFAULT);

  g_signal_connect ((gpointer) filechooserdialog1, "destroy",
                    G_CALLBACK (on_filechooserdialog1_close),
                    NULL);
  g_signal_connect ((gpointer) cancel_button2, "clicked",
                    G_CALLBACK (on_cancel_button2_clicked),
                    NULL);
  g_signal_connect ((gpointer) ok_button2, "clicked",
                    G_CALLBACK (on_ok_button2_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (filechooserdialog1, filechooserdialog1, "filechooserdialog1");
  GLADE_HOOKUP_OBJECT_NO_REF (filechooserdialog1, dialog_vbox2, "dialog_vbox2");
  GLADE_HOOKUP_OBJECT (filechooserdialog1, textview2, "textview2");
  GLADE_HOOKUP_OBJECT_NO_REF (filechooserdialog1, dialog_action_area2, "dialog_action_area2");
  GLADE_HOOKUP_OBJECT (filechooserdialog1, cancel_button2, "cancel_button2");
  GLADE_HOOKUP_OBJECT (filechooserdialog1, ok_button2, "ok_button2");

  gtk_widget_grab_default (ok_button2);
  return filechooserdialog1;
}

GtkWidget*
create_filechooserdialog2 (void)
{
  GtkWidget *filechooserdialog2;
  GtkWidget *dialog_vbox3;
  GtkWidget *dialog_action_area3;
  GtkWidget *save_cancel_button;
  GtkWidget *save_ok_button;

  filechooserdialog2 = gtk_file_chooser_dialog_new ("", NULL, GTK_FILE_CHOOSER_ACTION_SAVE, NULL);
  gtk_window_set_type_hint (GTK_WINDOW (filechooserdialog2), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox3 = GTK_DIALOG (filechooserdialog2)->vbox;
  gtk_widget_show (dialog_vbox3);

  dialog_action_area3 = GTK_DIALOG (filechooserdialog2)->action_area;
  gtk_widget_show (dialog_action_area3);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area3), GTK_BUTTONBOX_END);

  save_cancel_button = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (save_cancel_button);
  gtk_dialog_add_action_widget (GTK_DIALOG (filechooserdialog2), save_cancel_button, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (save_cancel_button, GTK_CAN_DEFAULT);

  save_ok_button = gtk_button_new_from_stock ("gtk-save");
  gtk_widget_show (save_ok_button);
  gtk_dialog_add_action_widget (GTK_DIALOG (filechooserdialog2), save_ok_button, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (save_ok_button, GTK_CAN_DEFAULT);

  g_signal_connect ((gpointer) filechooserdialog2, "destroy",
                    G_CALLBACK (on_filechooserdialog2_close),
                    NULL);
  g_signal_connect_swapped ((gpointer) save_cancel_button, "clicked",
                            G_CALLBACK (gtk_widget_destroy),
                            GTK_OBJECT (filechooserdialog2));
  g_signal_connect ((gpointer) save_ok_button, "clicked",
                    G_CALLBACK (on_save_ok_button_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (filechooserdialog2, filechooserdialog2, "filechooserdialog2");
  GLADE_HOOKUP_OBJECT_NO_REF (filechooserdialog2, dialog_vbox3, "dialog_vbox3");
  GLADE_HOOKUP_OBJECT_NO_REF (filechooserdialog2, dialog_action_area3, "dialog_action_area3");
  GLADE_HOOKUP_OBJECT (filechooserdialog2, save_cancel_button, "save_cancel_button");
  GLADE_HOOKUP_OBJECT (filechooserdialog2, save_ok_button, "save_ok_button");

  gtk_widget_grab_default (save_ok_button);
  return filechooserdialog2;
}

GtkWidget*
create_fileselection (void)
{
  GtkWidget *fileselection;
  GtkWidget *dialog_vbox4;
  GtkWidget *dialog_action_area4;
  GtkWidget *cancel_button1;
  GtkWidget *ok_button1;

  fileselection = gtk_file_chooser_dialog_new ("Select File...", NULL, GTK_FILE_CHOOSER_ACTION_OPEN, NULL);
  gtk_window_set_type_hint (GTK_WINDOW (fileselection), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox4 = GTK_DIALOG (fileselection)->vbox;
  gtk_widget_show (dialog_vbox4);

  dialog_action_area4 = GTK_DIALOG (fileselection)->action_area;
  gtk_widget_show (dialog_action_area4);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area4), GTK_BUTTONBOX_END);

  cancel_button1 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancel_button1);
  gtk_dialog_add_action_widget (GTK_DIALOG (fileselection), cancel_button1, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancel_button1, GTK_CAN_DEFAULT);

  ok_button1 = gtk_button_new_from_stock ("gtk-open");
  gtk_widget_show (ok_button1);
  gtk_dialog_add_action_widget (GTK_DIALOG (fileselection), ok_button1, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (ok_button1, GTK_CAN_DEFAULT);

  g_signal_connect ((gpointer) fileselection, "destroy",
                    G_CALLBACK (on_fileselection_close),
                    NULL);
  g_signal_connect ((gpointer) cancel_button1, "clicked",
                    G_CALLBACK (on_cancel_button1_clicked),
                    NULL);
  g_signal_connect ((gpointer) ok_button1, "clicked",
                    G_CALLBACK (on_ok_button1_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (fileselection, fileselection, "fileselection");
  GLADE_HOOKUP_OBJECT_NO_REF (fileselection, dialog_vbox4, "dialog_vbox4");
  GLADE_HOOKUP_OBJECT_NO_REF (fileselection, dialog_action_area4, "dialog_action_area4");
  GLADE_HOOKUP_OBJECT (fileselection, cancel_button1, "cancel_button1");
  GLADE_HOOKUP_OBJECT (fileselection, ok_button1, "ok_button1");

  gtk_widget_grab_default (ok_button1);
  return fileselection;
}

GtkWidget*
create_about_window (void)
{
  GtkWidget *about_window;
  GtkWidget *vbox2;
  GtkWidget *logo_os;
  GtkWidget *about_text;
  GtkWidget *about_close_button;

  about_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request (about_window, 480, 265);
  gtk_window_set_position (GTK_WINDOW (about_window), GTK_WIN_POS_CENTER_ON_PARENT);
  gtk_window_set_resizable (GTK_WINDOW (about_window), FALSE);
  gtk_window_set_decorated (GTK_WINDOW (about_window), FALSE);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (about_window), vbox2);

  logo_os = create_pixmap (about_window, "logo_os.xpm");
  gtk_widget_show (logo_os);
  gtk_box_pack_start (GTK_BOX (vbox2), logo_os, TRUE, TRUE, 0);

  about_text = gtk_text_view_new ();
  gtk_widget_show (about_text);
  gtk_box_pack_start (GTK_BOX (vbox2), about_text, TRUE, TRUE, 0);
  gtk_text_view_set_justification (GTK_TEXT_VIEW (about_text), GTK_JUSTIFY_CENTER);
  gtk_text_buffer_set_text (gtk_text_view_get_buffer (GTK_TEXT_VIEW (about_text)), "\n\nophcrack v2.0\nPhilippe Oechslin. Cedric Tissieres\nhttp://www.objectif-securite.ch\n", -1);

  about_close_button = gtk_button_new_with_mnemonic ("Close");
  gtk_widget_show (about_close_button);
  gtk_box_pack_start (GTK_BOX (vbox2), about_close_button, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (about_close_button), GTK_RELIEF_NONE);

  g_signal_connect ((gpointer) about_close_button, "clicked",
                    G_CALLBACK (on_about_close_button_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (about_window, about_window, "about_window");
  GLADE_HOOKUP_OBJECT (about_window, vbox2, "vbox2");
  GLADE_HOOKUP_OBJECT (about_window, logo_os, "logo_os");
  GLADE_HOOKUP_OBJECT (about_window, about_text, "about_text");
  GLADE_HOOKUP_OBJECT (about_window, about_close_button, "about_close_button");

  return about_window;
}

GtkWidget*
create_menu1 (void)
{
  GtkWidget *menu1;
  GtkWidget *from__sam;
  GtkWidget *local_pwdump1;
  GtkWidget *remote_pwdump1;

  menu1 = gtk_menu_new ();

  from__sam = gtk_menu_item_new_with_mnemonic ("From encrypted SAM");
  gtk_widget_show (from__sam);
  gtk_container_add (GTK_CONTAINER (menu1), from__sam);

  local_pwdump1 = gtk_menu_item_new_with_mnemonic ("From local SAM");
  gtk_widget_show (local_pwdump1);
  gtk_container_add (GTK_CONTAINER (menu1), local_pwdump1);

  remote_pwdump1 = gtk_menu_item_new_with_mnemonic ("From remote SAM");
  gtk_widget_show (remote_pwdump1);
  gtk_container_add (GTK_CONTAINER (menu1), remote_pwdump1);

  g_signal_connect ((gpointer) from__sam, "activate",
                    G_CALLBACK (on_from__sam_activate),
                    NULL);
  g_signal_connect ((gpointer) local_pwdump1, "activate",
                    G_CALLBACK (on_local_pwdump1_activate),
                    NULL);
  g_signal_connect ((gpointer) remote_pwdump1, "activate",
                    G_CALLBACK (on_remote_pwdump1_activate),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (menu1, menu1, "menu1");
  GLADE_HOOKUP_OBJECT (menu1, from__sam, "from__sam");
  GLADE_HOOKUP_OBJECT (menu1, local_pwdump1, "local_pwdump1");
  GLADE_HOOKUP_OBJECT (menu1, remote_pwdump1, "remote_pwdump1");

  return menu1;
}

GtkWidget*
create_dialog_remote_dump (void)
{
  GtkWidget *dialog_remote_dump;
  GtkWidget *dialog_vbox5;
  GtkWidget *table1;
  GtkWidget *label4;
  GtkWidget *label5;
  GtkWidget *label6;
  GtkWidget *target_hostname;
  GtkWidget *target_share;
  GtkWidget *target_user;
  GtkWidget *dialog_action_area5;
  GtkWidget *remote_cancel_button;
  GtkWidget *remote_ok_button;

  dialog_remote_dump = gtk_dialog_new ();
  gtk_widget_set_size_request (dialog_remote_dump, 550, 125);
  gtk_window_set_title (GTK_WINDOW (dialog_remote_dump), "Remote SAM parameters");
  gtk_window_set_default_size (GTK_WINDOW (dialog_remote_dump), 550, 125);
  gtk_window_set_resizable (GTK_WINDOW (dialog_remote_dump), FALSE);
  gtk_window_set_type_hint (GTK_WINDOW (dialog_remote_dump), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox5 = GTK_DIALOG (dialog_remote_dump)->vbox;
  gtk_widget_show (dialog_vbox5);

  table1 = gtk_table_new (3, 2, FALSE);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox5), table1, TRUE, TRUE, 0);

  label4 = gtk_label_new ("Target hostname or IP");
  gtk_widget_show (label4);
  gtk_table_attach (GTK_TABLE (table1), label4, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label4), 0, 0.5);

  label5 = gtk_label_new ("Target share (if different from C$)");
  gtk_widget_show (label5);
  gtk_table_attach (GTK_TABLE (table1), label5, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label5), 0, 0.5);

  label6 = gtk_label_new ("Username (if different from current)");
  gtk_widget_show (label6);
  gtk_table_attach (GTK_TABLE (table1), label6, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label6), 0, 0.5);

  target_hostname = gtk_entry_new ();
  gtk_widget_show (target_hostname);
  gtk_table_attach (GTK_TABLE (table1), target_hostname, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_max_length (GTK_ENTRY (target_hostname), 60);
  gtk_entry_set_width_chars (GTK_ENTRY (target_hostname), 30);

  target_share = gtk_entry_new ();
  gtk_widget_show (target_share);
  gtk_table_attach (GTK_TABLE (table1), target_share, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_max_length (GTK_ENTRY (target_share), 60);
  gtk_entry_set_width_chars (GTK_ENTRY (target_share), 30);

  target_user = gtk_entry_new ();
  gtk_widget_show (target_user);
  gtk_table_attach (GTK_TABLE (table1), target_user, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_max_length (GTK_ENTRY (target_user), 60);
  gtk_entry_set_width_chars (GTK_ENTRY (target_user), 30);

  dialog_action_area5 = GTK_DIALOG (dialog_remote_dump)->action_area;
  gtk_widget_show (dialog_action_area5);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area5), GTK_BUTTONBOX_END);

  remote_cancel_button = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (remote_cancel_button);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog_remote_dump), remote_cancel_button, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (remote_cancel_button, GTK_CAN_DEFAULT);

  remote_ok_button = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (remote_ok_button);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog_remote_dump), remote_ok_button, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (remote_ok_button, GTK_CAN_DEFAULT);

  g_signal_connect ((gpointer) dialog_remote_dump, "destroy",
                    G_CALLBACK (on_dialog_remote_dump_close),
                    NULL);
  g_signal_connect ((gpointer) remote_cancel_button, "clicked",
                    G_CALLBACK (on_remote_cancel_button_clicked),
                    NULL);
  g_signal_connect ((gpointer) remote_ok_button, "clicked",
                    G_CALLBACK (on_remote_ok_button_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (dialog_remote_dump, dialog_remote_dump, "dialog_remote_dump");
  GLADE_HOOKUP_OBJECT_NO_REF (dialog_remote_dump, dialog_vbox5, "dialog_vbox5");
  GLADE_HOOKUP_OBJECT (dialog_remote_dump, table1, "table1");
  GLADE_HOOKUP_OBJECT (dialog_remote_dump, label4, "label4");
  GLADE_HOOKUP_OBJECT (dialog_remote_dump, label5, "label5");
  GLADE_HOOKUP_OBJECT (dialog_remote_dump, label6, "label6");
  GLADE_HOOKUP_OBJECT (dialog_remote_dump, target_hostname, "target_hostname");
  GLADE_HOOKUP_OBJECT (dialog_remote_dump, target_share, "target_share");
  GLADE_HOOKUP_OBJECT (dialog_remote_dump, target_user, "target_user");
  GLADE_HOOKUP_OBJECT_NO_REF (dialog_remote_dump, dialog_action_area5, "dialog_action_area5");
  GLADE_HOOKUP_OBJECT (dialog_remote_dump, remote_cancel_button, "remote_cancel_button");
  GLADE_HOOKUP_OBJECT (dialog_remote_dump, remote_ok_button, "remote_ok_button");

  return dialog_remote_dump;
}

GtkWidget*
create_dialog3 (void)
{
  GtkWidget *dialog3;
  GtkWidget *vbox3;
  GtkWidget *label7;
  GtkWidget *hbuttonbox1;
  GtkWidget *button4;

  dialog3 = gtk_dialog_new ();
  gtk_container_set_border_width (GTK_CONTAINER (dialog3), 15);
  gtk_window_set_title (GTK_WINDOW (dialog3), "Error");
  gtk_window_set_type_hint (GTK_WINDOW (dialog3), GDK_WINDOW_TYPE_HINT_DIALOG);

  vbox3 = GTK_DIALOG (dialog3)->vbox;
  gtk_widget_show (vbox3);

  label7 = gtk_label_new ("Error: you must at least \nspecify a target hostname of IP");
  gtk_widget_show (label7);
  gtk_box_pack_start (GTK_BOX (vbox3), label7, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label7), GTK_JUSTIFY_CENTER);
  gtk_label_set_line_wrap (GTK_LABEL (label7), TRUE);

  hbuttonbox1 = GTK_DIALOG (dialog3)->action_area;
  gtk_widget_show (hbuttonbox1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox1), GTK_BUTTONBOX_END);

  button4 = gtk_button_new_with_mnemonic ("OK");
  gtk_widget_show (button4);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog3), button4, 0);

  g_signal_connect_swapped ((gpointer) button4, "clicked",
                            G_CALLBACK (gtk_widget_destroy),
                            GTK_OBJECT (dialog3));

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (dialog3, dialog3, "dialog3");
  GLADE_HOOKUP_OBJECT_NO_REF (dialog3, vbox3, "vbox3");
  GLADE_HOOKUP_OBJECT (dialog3, label7, "label7");
  GLADE_HOOKUP_OBJECT_NO_REF (dialog3, hbuttonbox1, "hbuttonbox1");
  GLADE_HOOKUP_OBJECT (dialog3, button4, "button4");

  return dialog3;
}

